Sspi (JNA API)

com.sun.jna.platform.win32

## Interface Sspi

-     public interface Sspi

  Ported from Sspi.h. Microsoft Windows SDK 6.0A.
  Author:
    dblock[at]dblock.org

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Interface and Description
    --- | ---
    `static class` | `Sspi.CredHandle` Credentials handle.
    `static class` | `Sspi.CtxtHandle` Security context handle.
    `static class` | `Sspi.PSecHandle` A pointer to a SecHandle
    `static class` | `Sspi.PSecPkgInfo` A pointer to an array of SecPkgInfo structures.
    `static class` | `Sspi.SecBuffer` The SecBuffer structure describes a buffer allocated by a transport application to pass to a security package.
    `static class` | `Sspi.SecBufferDesc`
    `static class` | `Sspi.SecHandle` Security handle.
    `static class` | `Sspi.SecPkgContext_PackageInfo` The SecPkgContext_PackageInfo structure.
    `static class` | `Sspi.SecPkgInfo` The SecPkgInfo structure provides general information about a security package, such as its name and capabilities.
    `static class` | `Sspi.SECURITY_INTEGER` A security integer.
    `static class` | `Sspi.TimeStamp` A timestamp.

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static int` | `ISC_REQ_ALLOCATE_MEMORY` The security package allocates output buffers for you.
    `static int` | `ISC_REQ_CONFIDENTIALITY` Encrypt messages by using the EncryptMessage function.
    `static int` | `ISC_REQ_CONNECTION` The security context will not handle formatting messages.
    `static int` | `ISC_REQ_DELEGATE` The server can use the context to authenticate to other servers as the client.
    `static int` | `ISC_REQ_EXTENDED_ERROR` When errors occur, the remote party will be notified.
    `static int` | `ISC_REQ_INTEGRITY` Sign messages and verify signatures by using the EncryptMessage and MakeSignature functions.
    `static int` | `ISC_REQ_MUTUAL_AUTH` The mutual authentication policy of the service will be satisfied.
    `static int` | `ISC_REQ_REPLAY_DETECT` Detect replayed messages that have been encoded by using the EncryptMessage or MakeSignature functions.
    `static int` | `ISC_REQ_SEQUENCE_DETECT` Detect messages received out of sequence.
    `static int` | `ISC_REQ_STREAM` Support a stream-oriented connection.
    `static int` | `MAX_TOKEN_SIZE` Maximum size in bytes of a security token.
    `static int` | `SECBUFFER_DATA` This buffer type is used for common data.
    `static int` | `SECBUFFER_EMPTY` This is a placeholder in the buffer array.
    `static int` | `SECBUFFER_TOKEN` This buffer type is used to indicate the security token portion of the message.
    `static int` | `SECBUFFER_VERSION` Version of the SecBuffer struct.
    `static int` | `SECPKG_ATTR_PACKAGE_INFO` The pBuffer parameter contains a pointer to a `Sspi.SecPkgContext_PackageInfo` structure.
    `static int` | `SECPKG_CRED_INBOUND` Validate an incoming server credential.
    `static int` | `SECPKG_CRED_OUTBOUND` Allow a local client credential to prepare an outgoing token.
    `static int` | `SECPKG_FLAG_ACCEPT_WIN32_NAME` Accepts Win32 names
    `static int` | `SECPKG_FLAG_APPCONTAINER_CHECKS` This package receives calls from app container apps if one of the following checks succeeds.
    `static int` | `SECPKG_FLAG_APPCONTAINER_PASSTHROUGH` This package receives all calls from app container apps.
    `static int` | `SECPKG_FLAG_ASCII_BUFFERS` Token Buffers are in ASCII
    `static int` | `SECPKG_FLAG_CLIENT_ONLY` Server side functionality not available
    `static int` | `SECPKG_FLAG_CONNECTION` Connection oriented RPC support
    `static int` | `SECPKG_FLAG_DATAGRAM` Datagram RPC support
    `static int` | `SECPKG_FLAG_DELEGATION` Package can delegate
    `static int` | `SECPKG_FLAG_EXTENDED_ERROR` Supports extended error msgs
    `static int` | `SECPKG_FLAG_FRAGMENT` Package can fragment to fit
    `static int` | `SECPKG_FLAG_GSS_COMPATIBLE` GSS Compatibility Available
    `static int` | `SECPKG_FLAG_IMPERSONATION` Supports impersonation
    `static int` | `SECPKG_FLAG_INTEGRITY` Supports integrity on messages
    `static int` | `SECPKG_FLAG_LOGON` Supports common LsaLogonUser
    `static int` | `SECPKG_FLAG_MULTI_REQUIRED` Full 3-leg required for re-auth.
    `static int` | `SECPKG_FLAG_MUTUAL_AUTH` Package can perform mutual authentication
    `static int` | `SECPKG_FLAG_NEGO_EXTENDER` The security package extends the Microsoft Negotiate security package.
    `static int` | `SECPKG_FLAG_NEGOTIABLE` Can be used by the negotiate package
    `static int` | `SECPKG_FLAG_NEGOTIABLE2` This package is negotiated by the package of type SECPKG_FLAG_NEGO_EXTENDER.
    `static int` | `SECPKG_FLAG_PRIVACY` Supports privacy (confidentiality)
    `static int` | `SECPKG_FLAG_RESTRICTED_TOKENS` Supports callers with restricted tokens.
    `static int` | `SECPKG_FLAG_STREAM` Supports stream semantics
    `static int` | `SECPKG_FLAG_TOKEN_ONLY` Only security token needed
    `static int` | `SECURITY_NATIVE_DREP` Specifies Native data representation.

- - ### Field Detail

    - #### MAX_TOKEN_SIZE

          static final int MAX_TOKEN_SIZE

      Maximum size in bytes of a security token.
      See Also:
        Constant Field Values

    - #### SECPKG_CRED_INBOUND

          static final int SECPKG_CRED_INBOUND

      Validate an incoming server credential. Inbound credentials might be validated by using an authenticating authority when InitializeSecurityContext or AcceptSecurityContext is called. If such an authority is not available, the function will fail and return SEC_E_NO_AUTHENTICATING_AUTHORITY. Validation is package specific.
      See Also:
        Constant Field Values

    - #### SECPKG_CRED_OUTBOUND

          static final int SECPKG_CRED_OUTBOUND

      Allow a local client credential to prepare an outgoing token.
      See Also:
        Constant Field Values

    - #### SECURITY_NATIVE_DREP

          static final int SECURITY_NATIVE_DREP

      Specifies Native data representation.
      See Also:
        Constant Field Values

    - #### ISC_REQ_ALLOCATE_MEMORY

          static final int ISC_REQ_ALLOCATE_MEMORY

      The security package allocates output buffers for you. When you have finished using the output buffers, free them by calling the FreeContextBuffer function.
      See Also:
        Constant Field Values

    - #### ISC_REQ_CONFIDENTIALITY

          static final int ISC_REQ_CONFIDENTIALITY

      Encrypt messages by using the EncryptMessage function.
      See Also:
        Constant Field Values

    - #### ISC_REQ_CONNECTION

          static final int ISC_REQ_CONNECTION

      The security context will not handle formatting messages. This value is the default.
      See Also:
        Constant Field Values

    - #### ISC_REQ_DELEGATE

          static final int ISC_REQ_DELEGATE

      The server can use the context to authenticate to other servers as the client. The ISC_REQ_MUTUAL_AUTH flag must be set for this flag to work. Valid for Kerberos. Ignore this flag for constrained delegation.
      See Also:
        Constant Field Values

    - #### ISC_REQ_EXTENDED_ERROR

          static final int ISC_REQ_EXTENDED_ERROR

      When errors occur, the remote party will be notified.
      See Also:
        Constant Field Values

    - #### ISC_REQ_INTEGRITY

          static final int ISC_REQ_INTEGRITY

      Sign messages and verify signatures by using the EncryptMessage and MakeSignature functions.
      See Also:
        Constant Field Values

    - #### ISC_REQ_MUTUAL_AUTH

          static final int ISC_REQ_MUTUAL_AUTH

      The mutual authentication policy of the service will be satisfied.
      See Also:
        Constant Field Values

    - #### ISC_REQ_REPLAY_DETECT

          static final int ISC_REQ_REPLAY_DETECT

      Detect replayed messages that have been encoded by using the EncryptMessage or MakeSignature functions.
      See Also:
        Constant Field Values

    - #### ISC_REQ_SEQUENCE_DETECT

          static final int ISC_REQ_SEQUENCE_DETECT

      Detect messages received out of sequence.
      See Also:
        Constant Field Values

    - #### ISC_REQ_STREAM

          static final int ISC_REQ_STREAM

      Support a stream-oriented connection.
      See Also:
        Constant Field Values

    - #### SECBUFFER_VERSION

          static final int SECBUFFER_VERSION

      Version of the SecBuffer struct.
      See Also:
        Constant Field Values

    - #### SECBUFFER_EMPTY

          static final int SECBUFFER_EMPTY

      This is a placeholder in the buffer array.
      See Also:
        Constant Field Values

    - #### SECBUFFER_DATA

          static final int SECBUFFER_DATA

      This buffer type is used for common data. The security package can read and write this data.
      See Also:
        Constant Field Values

    - #### SECBUFFER_TOKEN

          static final int SECBUFFER_TOKEN

      This buffer type is used to indicate the security token portion of the message. This is read-only for input parameters or read/write for output parameters.
      See Also:
        Constant Field Values

    - #### SECPKG_ATTR_PACKAGE_INFO

          static final int SECPKG_ATTR_PACKAGE_INFO

      The pBuffer parameter contains a pointer to a `Sspi.SecPkgContext_PackageInfo` structure. Returns information on the SSP in use.
      See Also:
        Constant Field Values

    - #### SECPKG_FLAG_INTEGRITY

          static final int SECPKG_FLAG_INTEGRITY

      Supports integrity on messages
      See Also:
        Constant Field Values

    - #### SECPKG_FLAG_PRIVACY

          static final int SECPKG_FLAG_PRIVACY

      Supports privacy (confidentiality)
      See Also:
        Constant Field Values

    - #### SECPKG_FLAG_TOKEN_ONLY

          static final int SECPKG_FLAG_TOKEN_ONLY

      Only security token needed
      See Also:
        Constant Field Values

    - #### SECPKG_FLAG_DATAGRAM

          static final int SECPKG_FLAG_DATAGRAM

      Datagram RPC support
      See Also:
        Constant Field Values

    - #### SECPKG_FLAG_CONNECTION

          static final int SECPKG_FLAG_CONNECTION

      Connection oriented RPC support
      See Also:
        Constant Field Values

    - #### SECPKG_FLAG_MULTI_REQUIRED

          static final int SECPKG_FLAG_MULTI_REQUIRED

      Full 3-leg required for re-auth.
      See Also:
        Constant Field Values

    - #### SECPKG_FLAG_CLIENT_ONLY

          static final int SECPKG_FLAG_CLIENT_ONLY

      Server side functionality not available
      See Also:
        Constant Field Values

    - #### SECPKG_FLAG_EXTENDED_ERROR

          static final int SECPKG_FLAG_EXTENDED_ERROR

      Supports extended error msgs
      See Also:
        Constant Field Values

    - #### SECPKG_FLAG_IMPERSONATION

          static final int SECPKG_FLAG_IMPERSONATION

      Supports impersonation
      See Also:
        Constant Field Values

    - #### SECPKG_FLAG_ACCEPT_WIN32_NAME

          static final int SECPKG_FLAG_ACCEPT_WIN32_NAME

      Accepts Win32 names
      See Also:
        Constant Field Values

    - #### SECPKG_FLAG_STREAM

          static final int SECPKG_FLAG_STREAM

      Supports stream semantics
      See Also:
        Constant Field Values

    - #### SECPKG_FLAG_NEGOTIABLE

          static final int SECPKG_FLAG_NEGOTIABLE

      Can be used by the negotiate package
      See Also:
        Constant Field Values

    - #### SECPKG_FLAG_GSS_COMPATIBLE

          static final int SECPKG_FLAG_GSS_COMPATIBLE

      GSS Compatibility Available
      See Also:
        Constant Field Values

    - #### SECPKG_FLAG_LOGON

          static final int SECPKG_FLAG_LOGON

      Supports common LsaLogonUser
      See Also:
        Constant Field Values

    - #### SECPKG_FLAG_ASCII_BUFFERS

          static final int SECPKG_FLAG_ASCII_BUFFERS

      Token Buffers are in ASCII
      See Also:
        Constant Field Values

    - #### SECPKG_FLAG_FRAGMENT

          static final int SECPKG_FLAG_FRAGMENT

      Package can fragment to fit
      See Also:
        Constant Field Values

    - #### SECPKG_FLAG_MUTUAL_AUTH

          static final int SECPKG_FLAG_MUTUAL_AUTH

      Package can perform mutual authentication
      See Also:
        Constant Field Values

    - #### SECPKG_FLAG_DELEGATION

          static final int SECPKG_FLAG_DELEGATION

      Package can delegate
      See Also:
        Constant Field Values

    - #### SECPKG_FLAG_RESTRICTED_TOKENS

          static final int SECPKG_FLAG_RESTRICTED_TOKENS

      Supports callers with restricted tokens.
      See Also:
        Constant Field Values

    - #### SECPKG_FLAG_NEGO_EXTENDER

          static final int SECPKG_FLAG_NEGO_EXTENDER

      The security package extends the Microsoft Negotiate security package.
      See Also:
        Constant Field Values

    - #### SECPKG_FLAG_NEGOTIABLE2

          static final int SECPKG_FLAG_NEGOTIABLE2

      This package is negotiated by the package of type SECPKG_FLAG_NEGO_EXTENDER.
      See Also:
        Constant Field Values

    - #### SECPKG_FLAG_APPCONTAINER_PASSTHROUGH

          static final int SECPKG_FLAG_APPCONTAINER_PASSTHROUGH

      This package receives all calls from app container apps.
      See Also:
        Constant Field Values

    - #### SECPKG_FLAG_APPCONTAINER_CHECKS

          static final int SECPKG_FLAG_APPCONTAINER_CHECKS

      This package receives calls from app container apps if one of the following checks succeeds.
      - Caller has default credentials capability.
      - The target is a proxy server.
      - The caller has supplied credentials.
      See Also:
        Constant Field Values

Copyright © 2007-2016 Timothy Wall. All Rights Reserved.